import pygame
import math
from character import *

white = (255, 255, 255)
green = (0, 255, 0)
blue = (0, 0, 128)
black = (0, 0, 0)

# Overall score && Health
health = 10
score = 0
clock = 0
time = 1
pre_timer = 4000

# top plane game
plane_timer = 3

# Add background and text font
background = pygame.image.load("Game_BG.jpg").convert()
pre_background = pygame.image.load("Game_BGpre.jpg").convert()
font = pygame.font.Font("Roboto-Medium.ttf", 32)

# Oil text
plane_text = font.render("%d"%time, True, black, white)
plane_text_rect = plane_text.get_rect()
plane_text_rect.center = (goldX, goldY)

# Pregame text
pre_text = font.render("Game will start in : %d"%(pre_timer/200), True, black, white)
pre_text_rect = pre_text.get_rect()
pre_text_rect.center = (512, 420)

# Score text | End text | life text
score_text = font.render("Score :%d"%time, True, black, white)
score_text_rect = score_text.get_rect()
score_text_rect.center = (512, 420)

end_text = font.render("You died ", True, black, white)
end_text_rect = end_text.get_rect()
end_text_rect.center = (520, 370)

life_text = font.render("life left :%d"%health, True, black, white)
life_text_rect = life_text.get_rect()
life_text_rect.center = (512, 420)

# Title and icon
pygame.display.set_caption("Super Multitask Game")
icon = pygame.image.load("icons8-space-32.png")
pygame.display.set_icon(icon)


# Game loop
running = True

# Game status
preplay = True
playing = False
endgame = False
while running:

    # Draw Background
    screen.fill((255, 255, 255))
    if preplay:
        pre_timer -= 1
        if pre_timer == 0:
            # Change state to playing
            preplay = False
            playing = True
            endgame = False
        screen.blit(pre_background, (0, 0))
        screen.blit(pre_text, pre_text_rect)
        pre_text = font.render("Game will start in : %d" % (pre_timer / 400), True, black, white)
    elif playing:
        screen.blit(background, (0, 0))

    # ถ้า health >=5 led ติดทั้ง 2 ดวง ใส่โค้ดตรงนี้
    # ถ้า health <5  led ติด 1 ดวง ใส่โค้ดตรงนี้
    # ถ้า health == 0 led ดับหมด ใส่โค้ดตรงนี้
    
    # เช่น if health>=5 :
    #                 set_led(1,1)
    #                 set_led(2,1)

    # Game End
    if health <= 0:
        preplay = False
        playing = False
        endgame = True

    # Overall Score | Clock
    clock += 1
    if clock % 1000 == 0 and playing:
        time += 1
        plane_timer -= 1
        print(time)
    if running:
        plane_text_rect.center = (goldX + 30, goldY + 30)
        plane_text = font.render("%d" % plane_timer, True, black, white)
        score_text = font.render("Score : %d" % time, True, black, white)
        life_text = font.render("life left :%d" % health, True, black, white)

    # Getting Event
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            running = False

        # Check if key is being press
        if event.type == pygame.KEYDOWN:
            # Check which key is been press | Modify here
            if event.key == pygame.K_LEFT or event.key == pygame.K_RIGHT:
                if event.key == pygame.K_LEFT:
                    print("press left arrow")
                    playerX_change -= playerSpeed
                elif event.key == pygame.K_RIGHT:
                    print("press right arrow")
                    playerX_change += playerSpeed
            if event.key == pygame.K_UP or event.key == pygame.K_DOWN:
                if event.key == pygame.K_UP:
                    print("press up key")
                    playerY_change -= playerSpeed
                elif event.key == pygame.K_DOWN:
                    print("press down key")
                    playerY_change += playerSpeed
            if event.key == pygame.K_w and controlling:
                print("press w")
                cactusY_change -= 0.3
            if event.key == pygame.K_s and controlling:
                print("press s")
                cactusY_change += 0.3
            if event.key == pygame.K_a:
                frontX_change -= 0.3
            if event.key == pygame.K_d:
                frontX_change += 0.3
            if event.key == pygame.K_KP_ENTER and endgame:
                print("Enter")
                health = 10
                pre_timer = 2000
                buildingX = 1100
                buildingY = random.randint(500, 700)
                building2X = 1500
                building2Y = random.randint(500, 700)
                preplay = True
                playing = False
                endgame = False
            """ if button_press():  ตรงนี้ต้องหา function button_press() ที่อาจารย์สอนรับค่าปุ่มที่ทำให้เวลากดปุ่ม จะได้ logic 1
                    print("Enter")
                    health = 10
                    pre_timer = 2000
                    buildingX = 1100
                    buildingY = random.randint(500, 700)
                    building2X = 1500
                    building2Y = random.randint(500, 700)
                    preplay = True
                    playing = False
                    endgame = False
            """

        if event.type == pygame.KEYUP:
            release_left = event.key == pygame.K_LEFT
            release_right = event.key == pygame.K_RIGHT
            release_up = event.key == pygame.K_UP
            release_down = event.key == pygame.K_DOWN
            release_w = event.key == pygame.K_w
            release_s = event.key == pygame.K_s
            release_a = event.key == pygame.K_a
            release_d = event.key == pygame.K_d
            if release_left or release_right:
                # print("release key X ")
                playerX_change = 0
            if release_up or release_down:
                # ("release key Y ")
                playerY_change = 0
            if release_w or release_s:
                cactusY_change = +0.1
            if release_a or release_d:
                frontX_change = 0

    # Position controller

    if playing:
        playerX += playerX_change
        playerY += playerY_change
        if controlling:
            cactusY += cactusY_change
        else:
            cactusY += 0.5
        frontX += frontX_change
        missileY -= math.log(clock, 100000)
        buildingX -= 1
        building2X -= 1

    # TOP PLANE GAME BORDER
    if playerX <= 500:
        playerX = 500
    if playerX >= 980:
        playerX = 980
    if playerY <= -10:
        playerY = -10
    if playerY >= 330:
        playerY = 330

    # Vertical plane game failed

    if cactusY <= 380:
        controlling = False
        cactusImg = pygame.image.load("aircraft_flip.png")
        cactusY = 380

    collisionB1 = (abs(cactusX - buildingX ) <= 27 )  and (cactusY >= (buildingY - 50))
    collisionB2 = (abs(cactusX - building2X) <= 27) and (cactusY >= (building2Y - 50))
    if collisionB1 or collisionB2:
        print("collision building 1")
        health -= 1
        # --ส่งเสียง buzzer ตรงนี้ -------- อย่าลิม delay แล้วปิด ---------------------------------------------
        cactusY = 400

    # Front plane game border
    if frontX <= 20:
        frontX = 20
    if frontX >= 440:
        frontX = 440

    # Side plane game building
    if buildingX <= -200:
        buildingX = 1100
        buildingY = random.randint(500, 700)
    if building2X <= -200:
        building2X = random.randint(1100, 1500)
        building2Y = random.randint(500, 700)


    # Failed top plane game

    if plane_timer == 0:
        health -= 1
        # --ส่งเสียง buzzer ตรงนี้ -------- อย่าลิม delay แล้วปิด ---------------------------------------------
        plane_timer = 3
        goldX = random.randint(530, 960)
        goldY = random.randint(10, 300)

    # Failed vertical plane game

    if cactusY >= 750:
        print(">>> plane crash <<<<")
        health -= 1
        # --ส่งเสียง buzzer ตรงนี้ -------- อย่าลิม delay แล้วปิด ---------------------------------------------
        cactusY = 500
        controlling = True
        cactusImg = pygame.image.load("aircraft2.png")

    # Failed front plane game

    if collide(frontX, frontY, missileX, missileY):
        print(">>>> plane has been hit <<<<")
        health -= 1
        # --ส่งเสียง buzzer ตรงนี้ -------- อย่าลิม delay แล้วปิด ---------------------------------------------
        missileX = random.randint(20, 450)
        missileY = 300

    if missileY < -30:
        missileX = random.randint(20, 450)
        missileY = 300


    # Collision check

    if collide(playerX, playerY, goldX, goldY):
        plane_timer = 3
        goldX = random.randint(530, 960)
        goldY = random.randint(10, 300)

    # Draw text
    if playing:
        # Insert another here
        # Display oil timer
        screen.blit(life_text, life_text_rect)
        screen.blit(plane_text, plane_text_rect)
    elif endgame:
        # Display end text
        screen.blit(end_text, end_text_rect)
        screen.blit(score_text, score_text_rect)



    # Draw player if only game is playing
    if playing or preplay:
        if playing:
            gold(screen, goldX, goldY)
        player(screen, playerX, playerY)
        cactus(screen, cactusX, cactusY)
        front(screen, frontX, frontY)
        if playing:
            missile(screen, missileX, missileY)
            B1(screen, buildingX, buildingY)
            B1(screen, building2X, building2Y)

    # Update everything that change
    pygame.display.update()

